

	#ifdef BASIC_CONFIG

		#define MAX_STRINGLEN					40
		#define MAX_GOSUB_STACK_DEPTH 10
		#define MAX_FOR_STACK_DEPTH		4
		#define MAX_VARNUM						26

	#endif


	#ifdef TOKENIZER_CONFIG

		#define MAX_USER_KEYWORD_LEN	16
		#define MAX_USER_PARAMS				4

	#endif


	#ifdef BASIC_TOKENS
	//TOKEN_WORD(name, text, function)
	//TOKEN_CHAR(name, char, function)
		TOKEN_WORD(TOKENIZER_LET,			"let"		, let_statement_2		)		
		TOKEN_WORD(TOKENIZER_PRINT,		"print" , print_statement		)
		TOKEN_WORD(TOKENIZER_IF,			"if"		, if_statement			)
		TOKEN_WORD(TOKENIZER_THEN,		"then"	, NO_FUNCTION				)
		TOKEN_WORD(TOKENIZER_ELSE,		"else"	, NO_FUNCTION				)
		TOKEN_WORD(TOKENIZER_FOR,			"for"		, for_statement			)
		TOKEN_WORD(TOKENIZER_TO,			"to"		, NO_FUNCTION				)
		TOKEN_WORD(TOKENIZER_NEXT,		"next"	, next_statement		)
		TOKEN_WORD(TOKENIZER_GOTO,		"goto"	, goto_statement		)
		TOKEN_WORD(TOKENIZER_GOSUB,		"gosub"	, gosub_statement		)
		TOKEN_WORD(TOKENIZER_RETURN,	"return", return_statement	)
		TOKEN_WORD(TOKENIZER_CALL,		"call"	, NO_FUNCTION				)
		TOKEN_WORD(TOKENIZER_END,			"end"		, end_statement			)
/*		TOKEN_WORD(TOKENIZER_SHR,			">>"		, basic_shift_right	)
		TOKEN_WORD(TOKENIZER_SHL,			"<<"		, basic_shift_left	)
		TOKEN_WORD(TOKENIZER_LE,			">="		, basic_rel_le			)
		TOKEN_WORD(TOKENIZER_GE,			"<="		, basic_rel_ge			)
		TOKEN_WORD(TOKENIZER_NE,			"<>"		, basic_rel_ne			)*/


		TOKEN_CHAR(TOKENIZER_COMMA,				',' , NO_EXPR_FUNC			)
		TOKEN_CHAR(TOKENIZER_SEMICOLON,		';' , NO_EXPR_FUNC			)
		TOKEN_CHAR(TOKENIZER_PLUS,				'+' , basic_add					)
		TOKEN_CHAR(TOKENIZER_MINUS,				'-' , basic_sub					)
		TOKEN_CHAR(TOKENIZER_AND,					'&' , basic_and					)
		TOKEN_CHAR(TOKENIZER_OR,					'|' , basic_or					)
		TOKEN_CHAR(TOKENIZER_XOR,					'^' , basic_xor					)
		TOKEN_CHAR(TOKENIZER_ASTR,				'*' , basic_mul					)
		TOKEN_CHAR(TOKENIZER_SLASH,				'/' , basic_div					)
		TOKEN_CHAR(TOKENIZER_MOD,					'%' , basic_mod					)
		TOKEN_CHAR(TOKENIZER_LEFTPAREN,		'(' , NO_EXPR_FUNC			)
		TOKEN_CHAR(TOKENIZER_RIGHTPAREN,	')' , NO_EXPR_FUNC			)
		TOKEN_CHAR(TOKENIZER_LEFTBRACK,		'[' , NO_EXPR_FUNC			)
		TOKEN_CHAR(TOKENIZER_RIGHTBRACK,	']' , NO_EXPR_FUNC			)
		TOKEN_CHAR(TOKENIZER_LT,					'<' , basic_rel_lt			)
		TOKEN_CHAR(TOKENIZER_GT,					'>' , basic_rel_gt			)
		TOKEN_CHAR(TOKENIZER_EQ,					'=' , basic_rel_eq			)
		TOKEN_CHAR(TOKENIZER_CR,					'\n', NO_EXPR_FUNC			)
																			
	#endif


	#ifdef BASIC_TOKEN_OPS

		TOKEN_CHAR_TERM(TOKENIZER_ASTR)
		TOKEN_CHAR_TERM(TOKENIZER_SLASH)
		TOKEN_CHAR_TERM(TOKENIZER_MOD)


		TOKEN_CHAR_EXPR(TOKENIZER_PLUS)
		TOKEN_CHAR_EXPR(TOKENIZER_MINUS)
		TOKEN_CHAR_EXPR(TOKENIZER_AND)
		TOKEN_CHAR_EXPR(TOKENIZER_OR)
/*		TOKEN_CHAR_EXPR(TOKENIZER_SHR)
		TOKEN_CHAR_EXPR(TOKENIZER_SHL)*/

		TOKEN_CHAR_REL(TOKENIZER_EQ)
		TOKEN_CHAR_REL(TOKENIZER_GT)
		TOKEN_CHAR_REL(TOKENIZER_LT)

	#endif


#ifdef BASIC_USER_EXTENSIONS
//USER_FUNCTION (name,text,func,param)
//USER_VARIABLE (name,text,var)
//USER_ARRAY    (name,text,var,size)

	USER_FUNCTION (LCD_PRINT,		"lcdout",   lcdoutfunc,   3)
	USER_FUNCTION (RESET_FUNC,	"reset",    resetfunc,		0)

	USER_FUNCTION (HALF_FUNC,		"half",     halffunc,		1)
	USER_FUNCTION (DBL_FUNC,		"double",   dblfunc,		1)

	USER_VARIABLE (SYSTICK,			"systick",  systick)

	USER_ARRAY    (ADC_ARRAY,		"adc",      adc,    8)



#endif
